unit constantes;

interface

uses windows, sysUtils, Forms,
   OOmisc, AwUser, AwWin32;

const
crENQ = char($05);
crEOT = char($04);
crESC = char($1B);
crAck = char($06);
crNAK = char($15);
crNUL = char($00);
LambdaMin = 190;
LambdaMax = 1100;
{$IFDEF DEBUG}
maxiAbs = 3.0;
{$ELSE}
maxiAbs = 2.0;
{$ENDIF}
DeltaLambdaMin = 100;
CharLambdaReg=AnsiChar(136);
CharLambda=WideChar($03BB);
crTab = char(vk_tab);
SymbReg: char   = '';
SymbReg2: char  = '&';
MaxNack = 5;
TimeOutms = 1000;
DureeMax = 60*60*24; // 24 heures

// bauds 9600
// longueur des bits de donnes 7
// parit:impair
// bit d'arrt 1
// paramtre X aucun

nomCarac : array[#0..#32] of string[32] = (
'NUL : Null',
'SOH : Start of heading',
'STX : Start of text',
'ETX : End of text',
'EOT : End of transmission',
'ENQ : Enquiry',
'ACK : Acknowledge',
'BEL : Bell',
'BS : Backspace',
'TAB : Tabulation',
'LF : Line Feed',
'VT : Vertical tabulation',
'FF : Form feed',
'CR : Carriage return',
'SO : Shift out',
'SI : Shift in',
'DLE : Data link escape',
'DC1 : Device control 1 XON',
'DC2 : Device control 2',
'DC3 : Device control 3 XOFF',
'DC4 : Device control 4',
'NAK : Negative acknowledgement',
'SYN : Synchronous',
'ETB : End of transmission block',
'CAN : Cancel',
'EM : End of medium',
'SUB : Substitute',
'ESC : Escape',
'FS : File separator',
'GS : Group separator',
'RS : Record separator',
'US : Unit separator',
'SP : Space'
);

function StrToFloatWin(nombre: string): double;
function FloatToStrPoint(valeur: double): String;
function IsPortAvailable(ComNum: cardinal): boolean;
function EncodeDuree(duree: longint): TdateTime;
function DureeEcoulee(InstantDebut: TdateTime): longint;

var nomIniFile : string;

implementation

function EncodeDuree(duree: longint): TdateTime;
var
   h, m, s, ms: word;
begin
   h  := duree div 3600;
   duree := duree - h * 3600;
   m  := duree div 60;
   duree := duree - m * 60;
   s  := duree;
   ms := 0;
   EncodeDuree := EncodeTime(h, m, s, ms);
end;

function DureeEcoulee(InstantDebut: TdateTime): longint;
var
   h, m, s, ms: word;
begin
   decodeTime(time - instantDebut, h, m, s, ms);
   DureeEcoulee := h * 3600 + m * 60 + s;
end;

function StrToFloatWin(nombre: string): double;
var
   posSeparator: integer;
begin
   if formatSettings.decimalSeparator <> '.' then begin
      posSeparator := pos('.', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := formatSettings.decimalSeparator;
   end
   else if formatSettings.decimalSeparator <> ',' then begin
      posSeparator := pos(',', nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := formatSettings.decimalSeparator;
   end;
   try
      StrToFloatWin := strToFloat(nombre);
   except
      StrToFloatWin := 0;
   end;
end;

function IsPortAvailable(ComNum: cardinal): boolean;

   function MakeComName(const Dest: PChar; const ComNum: cardinal): PChar;
      {-Return a string like 'COMXX'}
   begin
      StrFmt(Dest, '\\.\COM%d', [ComNum]);
      MakeComName := Dest;
   end;

var
   ComName: array[0..12] of char;
   Res: integer;
   DeviceLayer: TApdBaseDispatcher;
begin
   DeviceLayer := TApdWin32Dispatcher.Create(nil);
   try
      if (ComNum = 0) then
         Result := False
      else begin
         Res := DeviceLayer.OpenCom(MakeComName(ComName, ComNum), 64, 64);
         if (Res < 0) and (GetLastError <> DWORD(Abs(ecAccessDenied))) then
            Result := False
         else begin
            Result := True;
            DeviceLayer.CloseCom;
         end;
      end;
   finally
      DeviceLayer.Free;
   end;
end;

function FloatToStrPoint(valeur: double): String;
var
   nombre: String;
   posSeparator: byte;
begin
   nombre := FloatToStrF(valeur, ffGeneral, 7, 2);
   if formatSettings.decimalSeparator <> '.' then begin
      posSeparator := pos(formatSettings.decimalSeparator, nombre);
      if posSeparator > 0 then
         Nombre[posSeparator] := '.';
   end;
   Result := nombre;
end;

initialization
    nomIniFile := changeFileExt(application.exeName,'.ini');

end.
