﻿unit shimaCinet;

interface

uses Windows, Classes, Graphics, Forms, Controls, Menus,
   Dialogs, StdCtrls, Buttons, ExtCtrls, SysUtils, Messages, clipBrd,
   spin,ComCtrls, ToolWin,inifiles,
   system.UITypes, system.Types,
   ADport, ADexcept, oomisc, math,
   constantes, shimadzuMain, graphker, maths;

type
   TCinetiqueForm = class(TForm)
      SaveDialog:    TSaveDialog;
      Timer:         TTimer;
      Oscillo:       TPaintBox;
      BoutonsPanel:  TPanel;
      DureeEdit:     TEdit;
      DureeSB:       TSpinButton;
      LabelDeltat:   TLabel;
      PanelDuree:    TPanel;
      Label2:        TLabel;
      LambdaSE:      TSpinEdit;
      Label3:        TLabel;
      NbreEdit:      TEdit;
      NbreSpin:      TSpinButton;
      EditBidon:     TEdit;
      Label4:        TLabel;
      PanelAbs:      TPanel;
      ToolBar1:      TToolBar;
      SaveBtn:       TToolButton;
      RepereBtn:     TToolButton;
      ResetBtn:      TToolButton;
      StopBtn:       TToolButton;
    ZeroBtn: TToolButton;
      ExitBtn:       TToolButton;
      PrintBtn:      TToolButton;
      SavePopupMenu: TPopupMenu;
      RegressiM:     TMenuItem;
      ClipM:         TMenuItem;
      FileM:         TMenuItem;
    StatusBar1: TStatusBar;
    StartBtn: TToolButton;
    LambdaBtn: TSpeedButton;
      procedure ExitItemClick(Sender: TObject);
      procedure FormCreate(Sender: TObject);
      procedure TimerTimer(Sender: TObject);
      procedure InitAttente;
      procedure StartBtnClick(Sender: TObject);
      procedure OscilloPaint(Sender: TObject);
      procedure StopBtnClick(Sender: TObject);
      procedure ResetBtnClick(Sender: TObject);
      procedure FilePageItemClick(Sender: TObject);
      procedure RegPageBtnClick(Sender: TObject);
      procedure DureeSBDownClick(Sender: TObject);
      procedure DureeSBUpClick(Sender: TObject);
      procedure FormClose(Sender: TObject; var Action: TCloseAction);
      procedure ZeroBtnClick(Sender: TObject);
      procedure LambdaBtnClick(Sender: TObject);
      procedure ExitBtnClick(Sender: TObject);
      procedure FormDestroy(Sender: TObject);
      procedure LambdaSEChange(Sender: TObject);
      procedure NbreSpinDownClick(Sender: TObject);
      procedure NbreSpinUpClick(Sender: TObject);
      procedure NbreEditChange(Sender: TObject);
      procedure ZeroBtnBisClick(Sender: TObject);
      procedure PrintBtnClick(Sender: TObject);
      procedure RegressiMClick(Sender: TObject);
      procedure SaveBtnClick(Sender: TObject);
    procedure RepereBtnClick(Sender: TObject);
   private
      Hlambda:        integer;
      NbreMax:        integer;
      DureeMesure, DeltatMesure: word; // en s
      InstantDebut:   TdateTime;
      NomFichierData: string;
      DejaSauve, FormatRW3: boolean;
      fichier:  textFile;
      lambdaEnCours: boolean;
      procedure EcritPageRW3;
      procedure EcritPageTableur;
      procedure DureeSBClick;
      procedure ChangeNbre;
   public
      Graphe: Tgraphe;
      blancFait, lambdaFait : boolean;
      acqEnCours : boolean;
      procedure setAbs(valeurCourante : double);
      procedure setBoutons;
   protected
      procedure WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo); message wm_GetMinMaxInfo;
   end;

var
   CinetiqueForm: TCinetiqueForm;

implementation

uses shimaDDE, s250cst;

const
   minPoints = 10;
   deltatMin = 2; // soit duree Min 20 secondes

{$R *.DFM}

procedure TCinetiqueForm.ExitItemClick(Sender: TObject);
begin
   Close;
end;

procedure TCinetiqueForm.EcritPageRW3;
var
   j: indiceVecteur;
   repere : Trepere;
   i : integer;
begin with graphe do begin
      writeln(fichier, symbReg, 1, ' PAGE COMMENT');
      if constanteDlg.EditComm.Text <> '' then
         writeln(fichier, constanteDlg.EditComm.Text)
      else
         writeln(fichier, 'Suivi de cinétique par spectro shimadzu ' + DateTimeToStr(date + time));
      writeln(fichier, symbReg2, NbrePoints, ' VALEUR VAR');
      for j := 0 to pred(NbrePoints) do begin
         Write(fichier, FloatToStrPoint(mondeX.valeur[j]));
         Write(fichier, ' ', FloatToStrPoint(mondeY.valeur[j]));
         writeln(fichier);
      end; { for j }
      if ListeRepere.Count > 0 then begin
         writeln(fichier, symbReg2, ListeRepere.Count, ' REPERE');
         for i := 0 to pred(ListeRepere.Count) do begin
            repere := Trepere(listeRepere[i]);
            writeln(fichier, FloatToStrPoint(repere.valeur),
               crTab, repere.Text);
         end;
      end;
end end; // ecritPageRW3

procedure TCinetiqueForm.EcritPageTableur;
var j : indiceVecteur;
begin with graphe do begin
      for j := 0 to pred(NbrePoints) do begin
         Write(fichier, FloatToStrPoint(mondeX.valeur[j]));
         Write(fichier, crTab, FloatToStrPoint(mondeY.valeur[j]));
         writeln(fichier);
      end;
end end; // ecritPageTableur

procedure TCinetiqueForm.FormCreate(Sender: TObject);

Procedure LiTIni;
var ini : TiniFile;
begin
   Ini := TIniFile.Create(nomIniFile);
   try
      lambdaSE.value := Ini.ReadInteger( 'Lambda', 'Cinet', 500 );
      NbreMax  := Ini.ReadInteger( 'Cinet', 'Nombre', 120);
      deltatMesure := Ini.ReadInteger( 'Vitesse', 'Valeur', deltatMin);
   finally
     Ini.Free;
   end;
end;

begin
   Graphe := Tgraphe.Create;
   litIni;
   Hlambda := 0;
   Graphe.Canvas := Oscillo.Canvas;
   DejaSauve := False;
   InstantDebut := time;
   DureeMesure := DeltatMesure * NbreMax;
   DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
   NbreEdit.Text := IntToStr(NbreMax);
   LabelDeltat.Caption := 'dt=' + IntToStr(deltatMesure) + ' s';
   with graphe do begin
      mondeX.nom  := 't';
      mondeAbs.nom  := 'A';
      mondeX.signif := 'temps';
      mondeAbs.signif := 'Absorbance';
      mondeX.unite := 's';
      mondeAbs.unite := '';
      MondeX.Mini := 0;
      mondeAbs.mini := 0;
      MondeX.Maxi := dureeMesure;
      mondeAbs.maxi := maxiAbs;
      mondeY := mondeAbs;
   end;
   LambdaSE.MinValue := LambdaMin;
   LambdaSE.MaxValue := LambdaMax;
   LambdaSE.Value := 500;
   lambdaFait := false;
   blancFait := false;
   setBoutons;
end;

procedure TCinetiqueForm.TimerTimer(Sender: TObject);
begin
   FormMain.DemandeAbs;
end;

procedure TCinetiqueForm.setAbs(valeurCourante : double);
var temps : longInt;
begin
   if not isNan(valeurCourante) then with graphe do begin
      temps := DureeEcoulee(instantDebut);
      mondeX.valeur[NbrePoints] := temps;
      panelDuree.Caption := TimeToStr(time - instantDebut);
      panelAbs.Caption := floatToStrF(valeurCourante, ffFixed, 4, 3);
      mondeY.valeur[NbrePoints] := valeurCourante;
      traceUnPoint(NbrePoints);
      Inc(NbrePoints);
      SaveBtn.enabled := NbrePoints > minPoints;
      if temps > dureeMesure then begin
         AcqEnCours := false;
         SetBoutons;
      end;
end end;

procedure TCinetiqueForm.InitAttente;
var i: integer;
begin with graphe do begin
      timer.Enabled := False;
      DureeMesure := DeltatMesure * NbreMax;
      DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
      LabelDeltat.Caption := IntToStr(deltatMesure) + ' s';
      Reset;
      MondeX.Maxi := dureeMesure;
      for i := 0 to MaxData do
          mondeX.valeur[i] := i * deltatMesure;
      PanelDuree.Caption := '';
      PanelAbs.Caption := '';
      Oscillo.Refresh;
      SetBoutons;
end end; // InitAttente

procedure TCinetiqueForm.StartBtnClick(Sender: TObject);
begin
   if (graphe.nbrePoints>minPoints) and not DejaSauve and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   InstantDebut := time;
   DejaSauve := False;
   graphe.reset;
   AcqEnCours := true;
   SetBoutons;
   TimerTimer(nil); // valeur Initiale
end;

procedure TCinetiqueForm.OscilloPaint(Sender: TObject);
begin
   graphe.largeurEcran := (sender as TPaintBox).Width+2;
   graphe.Draw(oscillo.Canvas);
end;

procedure TCinetiqueForm.StopBtnClick(Sender: TObject);
begin
   if LambdaEnCours then begin
     FormMain.StopBtnClick(sender);
     LambdaEnCours := false;
     exit;
   end;
   timer.Enabled := false;
   if (Graphe.NbrePoints > minPoints)
      then begin
         acqEnCours := false;
         setBoutons
      end
      else ResetBtnClick(Sender);
end;

procedure TCinetiqueForm.SetBoutons;
var
   mini, maxi: double;
begin
   LambdaEnCours := false;
   StartBtn.enabled := lambdaFait and blancFait;
   ResetBtn.enabled := (graphe.nbrePoints>minPoints) and not AcqEnCours;
   StopBtn.enabled  := AcqEnCours;
   ExitBtn.enabled  := not AcqEnCours;
   RepereBtn.Enabled := AcqEnCours;
   LambdaBtn.enabled := not AcqEnCours;
   ZeroBtn.enabled := not AcqEnCours;
   LambdaSE.Enabled := not AcqEnCours;
 {$IFDEF DEBUG}
  SaveBtn.enabled  := true;
  {$ELSE}
   SaveBtn.enabled  := (graphe.nbrePoints>minPoints);
   {$ENDIF }
   PanelDuree.Visible := AcqEnCours;
   PanelAbs.Visible := AcqEnCours;
   NbreSpin.enabled := not AcqEnCours;
   NbreEdit.Enabled := not AcqEnCours;

   timer.Interval := DeltatMesure * 1000;
   Timer.Enabled := AcqEnCours;
   if (graphe.nbrePoints>minPoints) then begin
      GetMinMax(graphe.mondeY.valeur, graphe.NbrePoints, mini, maxi);
      if maxi < 1 then maxi := 1;
      graphe.SetMonde(0, 0, dureeMesure, maxi);
      Oscillo.refresh;
   end;
end;

procedure TCinetiqueForm.ResetBtnClick(Sender: TObject);
begin with graphe do begin
      reset;
      Oscillo.refresh;
      setBoutons;
      PanelDuree.Caption := '';
      PanelAbs.Caption := '';
end end;

procedure TCinetiqueForm.FilePageItemClick(Sender: TObject);
begin
   AssignFile(fichier, NomFichierData);
   Append(fichier);
   if formatRW3
      then ecritPageRW3
      else ecritPageTableur;
   CloseFile(fichier);
end;

procedure TCinetiqueForm.RegPageBtnClick(Sender: TObject);
begin
   if ConstanteDlg.showModal = mrOk then begin
      FormDDE.EnvoieDonneesCinetique(graphe,True);
      constanteDlg.newPageCB.ItemIndex := 1;
   end;
end;

procedure TCinetiqueForm.DureeSBClick;
begin
   if NbreMax > maxDataCinet then NbreMax := maxDataCinet;
   DureeMesure := DeltatMesure * NbreMax;
   DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
   LabelDeltat.Caption := IntToStr(deltatMesure) + ' s';
   graphe.MondeX.Maxi := dureeMesure;
   NbreEdit.Text  := IntToStr(NbreMax);
   timer.Interval := DeltatMesure * 1000;
   Oscillo.refresh;
end;

procedure TCinetiqueForm.DureeSBUpClick(Sender: TObject);
var
   k: indiceVecteur;
begin
   if AcqEnCours then
      if NbreMax < (2 * MaxDataCinet div 3) then
         NbreMax := NbreMax * 3 div 2
      else begin
         Inc(DeltatMesure);
         with graphe do
            if NbrePoints > (MaxDataCinet div 2) then begin
               // supprimer un point sur 2
               NbrePoints := NbrePoints div 2;
               for k := 1 to pred(NbrePoints) do begin
                  mondeX.valeur[k] := mondeX.valeur[2 * k];
                  mondeY.valeur[k] := mondeY.valeur[2 * k];
               end;
            end;
      end
   else if deltatMesure < 60 then begin
      Inc(deltatMesure);
      if DeltatMesure * NbreMax > DureeMax then
         NbreMax := DureeMax div DeltatMesure;
   end;
   DureeSBclick;
end;

procedure TCinetiqueForm.DureeSBDownClick(Sender: TObject);
begin
   if DeltatMesure > deltatMin
   then Dec(deltatMesure)
   else begin
      NbreMax := 2 * NbreMax div 3;
      if NbreMax < minPoints then
         NbreMax := minPoints;
   end;
   DureeSBclick;
end;

procedure TCinetiqueForm.FormClose(Sender: TObject; var Action: TCloseAction);

Procedure EcritIni;
var ini : TiniFile;
begin
   Ini := TIniFile.Create(nomIniFile);
   try
      Ini.WriteInteger( 'Lambda', 'Cinet', lambdaSE.value );
      Ini.WriteInteger( 'Cinet', 'Nombre',  NbreMax  );
      Ini.WriteInteger( 'Vitesse', 'Valeur', deltatMesure);
   finally
     Ini.Free;
   end;
end;

begin
   if AcqEncours then stopBtnClick(Sender);
   if (graphe.nbrePoints>minPoints) and not DejaSauve and
      (MessageDlg('Sauvegarde', mtConfirmation, [mbYes, mbNo], 0) = idYes) then
      SaveBtnClick(Sender);
   ecritIni;
   Timer.Enabled := False;
end;

procedure TCinetiqueForm.ZeroBtnClick(Sender: TObject);
begin
   FormMain.setZero;
   initAttente;
end;

procedure TCinetiqueForm.LambdaBtnClick(Sender: TObject);
begin
      LambdaBtn.enabled := False;
      StartBtn.enabled := False;
      ZeroBtn.enabled := false;
      stopBtn.Enabled := true;
      LambdaEnCours := true;
      FormMain.setLambda(lambdaSE.Value);
      blancFait := false;
end;

procedure TCinetiqueForm.WMGetMinMaxInfo(var Msg: TWMGetMinMaxInfo);
begin
   with Msg.MinMaxInfo^ do begin
      ptMinTrackSize := point(550, 120);
      ptMaxTrackSize := point(screen.Width - 20, screen.Height - 20);
   end;
end;

procedure TCinetiqueForm.ExitBtnClick(Sender: TObject);
begin
   Close;
end;

procedure TCinetiqueForm.FormDestroy(Sender: TObject);
begin
   Graphe.Free;
   cinetiqueForm := nil;
end;

procedure TCinetiqueForm.LambdaSEChange(Sender: TObject);
begin
   lambdaFait := false;
   blancFait := false;
   setBoutons;
end;

procedure TCinetiqueForm.ChangeNbre;
begin
   if NbreMax > MaxDataCinet then begin
      inc(deltatMesure);
      LabelDeltat.Caption := 'dt=' + IntToStr(deltatMesure) + ' s';
      NbreMax := MaxDataCinet;
   end;
   if NbreMax < minPoints then
      NbreMax := minPoints;
   if NbreMax >= 300 then
      NbreMax := 60 * (NbreMax div 60);
   if NbreMax >= 90 then
      NbreMax := 30 * (NbreMax div 30);
   if NbreMax >= 30 then
      NbreMax := 10 * (NbreMax div 10);
   NbreEdit.Text := IntToStr(NbreMax);
   dureeMesure := deltatMesure*NbreMax;
   DureeEdit.Text := TimeToStr(EncodeDuree(DureeMesure));
   LabelDeltat.Caption := IntToStr(deltatMesure) + ' s';
   graphe.MondeX.Maxi := dureeMesure;
   timer.Interval := DeltatMesure * 1000;
   Oscillo.refresh;
end;

procedure TCinetiqueForm.NbreSpinDownClick(Sender: TObject);
begin
   if NbreMax >= 360 then
      Dec(NbreMax, 60)
   else if NbreMax >= 120 then
      Dec(NbreMax, 30)
   else if NbreMax >= 40 then
      Dec(NbreMax, 10)
   else
      Dec(NbreMax);
   ChangeNbre;
end;

procedure TCinetiqueForm.NbreSpinUpClick(Sender: TObject);
begin
   if NbreMax >= 300 then
      Inc(NbreMax, 60)
   else if NbreMax >= 90 then
      Inc(NbreMax, 30)
   else if NbreMax >= 30 then
      Inc(NbreMax, 10)
   else
      Inc(NbreMax);
   ChangeNbre;
end;

procedure TCinetiqueForm.NbreEditChange(Sender: TObject);
begin
   NbreMax := StrToInt(NbreEdit.Text);
   ChangeNbre;
end;

procedure TCinetiqueForm.ZeroBtnBisClick(Sender: TObject);
begin
   FormMain.setZero;
end;

procedure TCinetiqueForm.PrintBtnClick(Sender: TObject);
begin
   Graphe.imprime;
end;

procedure TCinetiqueForm.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

procedure TCinetiqueForm.RepereBtnClick(Sender: TObject);
var
   texte: string;
   InstantClick: double;
begin
    instantClick := DureeEcoulee(instantDebut);
    texte := InputBox('Création d''un repère', 'Signification', '');
    graphe.AjouteRepere(instantClick, texte);
end;

procedure TCinetiqueForm.SaveBtnClick(Sender: TObject);

   procedure SaveItem;

      procedure ecritEnTeteTableur;
      begin with graphe do begin
            writeln(fichier, 'Cinétique avec shimadzu');
            writeln(fichier, 't' + crTab + 'A');
            writeln(fichier, 's' + crTab + '');
      end end; // ecritEnTeteTableur

      procedure ecritEnTeteRW3;
      begin with graphe, constanteDlg do begin
            writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
            writeln(fichier, symbReg, '2 NOM VAR');
            writeln(fichier, 't');
            writeln(fichier, 'A');
            writeln(fichier, symbReg, '2 UNITE VAR');
            writeln(fichier, 's');
            writeln(fichier, '');
            writeln(fichier, symbReg, '2 SIGNIF VAR');
            writeln(fichier, 'durée');
            writeln(fichier, 'Absorbance');
            writeln(fichier, symbReg, '1 ACQUISITION');
            writeln(fichier, Application.ExeName);
      end end; // ecritEnTeteRW3

   begin
      SaveDialog.filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
      SaveDialog.defaultExt := 'RW3';
      if SaveDialog.Execute then begin
         FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName)) = '.RW3';
         NomFichierData := saveDialog.FileName;
         try
            AssignFile(fichier, saveDialog.FileName);
            Rewrite(fichier);
            DejaSauve := True;
            if formatRW3 then begin
               ecritEnTeteRW3;
               ecritPageRW3;
            end
            else begin
               ecritEnTeteTableur;
               ecritPageTableur;
            end;
            CloseFile(fichier);
         except
            ShowMessage('Erreur d''écriture du fichier');
         end;
      end;
   end;

begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then begin
         DejaSauve := True;
         FormDDE.EnvoieDonneesCinetique(graphe,True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then begin
      DejaSauve := True;
      FormDDE.EnvoieDonneesCinetique(graphe,False);
   end;
   if fileM.Checked then SaveItem;
end;

end.

