unit shimadde;

interface

uses
  SysUtils, Windows, Messages, Classes, Graphics, Controls,system.UITypes,
  Forms, Dialogs, StdCtrls, DdeMan, ExtCtrls, registry, clipbrd, shellApi,
  constantes, graphker, shimadzuMain, maths;

type
  Tenvoi = (eAdd,eLoad,ePlus,eAddCol);

  TFormDDE = class(TForm)
    ClientDDE: TDdeClientConv;
    ClientItem: TDdeClientItem;
    ServeurDDE: TDdeServerConv;
    procedure FormCreate(Sender: TObject);
    procedure ExecuteMacro(Sender: TObject; Msg: TStrings);
  private
  public
    procedure AjouteOptionGr(Agraphe : Tgraphe;var donnees : TstringList);
    procedure Execute(Ordre : Tenvoi);
    procedure EnvoieDonneesSpectre(Agraphe : Tgraphe;DDE : boolean);
    procedure EnvoieDonneesCinetique(Agraphe : Tgraphe;DDE : boolean);
  end;

var
  FormDDE: TFormDDE;

implementation

uses S250CST, shimaCinet;

{$R *.DFM}

procedure TFormDDE.AjouteOptionGr(Agraphe : TGraphe;var donnees : TstringList);
begin
     donnees.Add(symbReg2+'1 NOMX');
     donnees.Add(Agraphe.mondeX.nom);
     donnees.Add(symbReg2+'1 NOMY');
     donnees.Add(Agraphe.mondeY.nom);
     donnees.Add(symbReg2+'1 COULEUR');
     donnees.Add(IntToStr(couleurCourbe));
     donnees.Add(symbReg2+'1 LIGNE');
     donnees.Add('2') // ligne
end;

procedure TFormDDE.Execute(Ordre : Tenvoi);

Procedure lanceRegressi;
var hSemaphore : integer;
    CharVal: array[0..1024] of Char;
begin
   hSemaphore := CreateSemaphore(nil,0,1,'Regressi');
   if (hSemaphore<>0) and
      (GetLastError = Error_Already_Exists) then exit;
   StrPCopy(CharVal, ClientDde.ServiceApplication);
   if ShellExecute(0, 'open', Pchar(ClientDde.ServiceApplication),
                   nil, nil, SW_SHOWDEFAULT) >= 32 then sleep(2000);
end;

procedure Lance;
begin
    case ordre of
         eAdd : if not ClientDDE.ExecuteMacro('CLIP|ADD', false) then
            ShowMessage('Transfert non excut');
         eLoad : if not ClientDDE.ExecuteMacro('CLIP|LOAD', false) then
            ShowMessage('Transfert non excut');
         ePlus : if not ClientDDE.ExecuteMacro('CLIP|PLUS', false) then
            ShowMessage('Transfert non excut');
         eAddCol : if not ClientDDE.ExecuteMacro('CLIP|ADDCOL', false) then
            ShowMessage('Transfert non excut');
    end;
    ClientDDE.CloseLink;
end;

begin
     LanceRegressi;
     ClientDDE.SetLink('REGRESSI','ServeurDDE');
     ClientItem.DDEItem := 'ServeurItem';
     if ClientDDE.OpenLink
       then lance
       else begin // On ressaye
               // OpenLik false efface 
           ClientDDE.SetLink('Regressi','ServeurDDE');
           ClientItem.DDEItem := 'ServeurItem';
           sleep(1000);
           if ClientDDE.OpenLink
              then lance
              else ShowMessage('Impossible de lancer Regressi');
       end;
end;

procedure TFormDDE.EnvoieDonneesSpectre(Agraphe : Tgraphe;DDE : boolean);
var donnees : TstringList;

procedure ecritOld(i : integer);
var LigneCourante : String;
    inverse : boolean;
    k,j : integer;
begin with Agraphe do begin
     donnees.clear;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Spectre  '+DateTimeToStr(date+time));
     Donnees.Add(constanteDlg.editComm.text);
     LigneCourante := CharLambda+crTab+mondeAbs.nom+crTab+mondeTrans.nom;
     Donnees.Add(LigneCourante);
     LigneCourante := 'nm'+crTab+''+crTab+'%';
     Donnees.Add(LigneCourante);
     LigneCourante := 'Longueur d''onde'+crTab+Titre;
     Donnees.Add(LigneCourante);
     inverse := listeDonnees[i].X[0]>listeDonnees[i].X[1];
     for k := 0 to pred(listeDonnees[i].Nombre) do begin
         if inverse then j := NbrePoints-k-1 else j := k;
         LigneCourante := FloatToStrPoint(listeDonnees[i].X[j])+
            crTab+FloatToStrPoint(listeDonnees[i].A[j])+
            crTab+FloatToStrPoint(listeDonnees[i].T[j]);
         Donnees.Add(LigneCourante);
     end;
     ClipBoard.asText := donnees.text;
end end;

var i,j,imax : integer;
    LigneCourante : String;
    inverse : boolean;
begin with Agraphe do begin
     Donnees := TstringList.Create;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Spectre  '+DateTimeToStr(date+time));
     Donnees.Add(constanteDlg.editComm.text);
     LigneCourante := CharLambda+crTab+mondeAbs.nom+crTab+MondeTrans.nom;
     Donnees.Add(LigneCourante);
     LigneCourante := 'nm'+crTab+mondeAbs.unite+crTab+mondeTrans.unite;
     Donnees.Add(LigneCourante);
     LigneCourante := 'Longueur d''onde'+crTab+mondeAbs.signif+crTab+mondeTrans.signif;
     Donnees.Add(LigneCourante);
     inverse := mondeX.valeur[0]>mondeX.valeur[1];
     for i := 0 to pred(NbrePoints) do begin
         if inverse then j := NbrePoints-i-1 else j := i;
         LigneCourante := FloatToStrPoint(mondeX.valeur[j])+crTab+
             FloatToStrPoint(mondeAbs.valeur[j])+crTab+
             FloatToStrPoint(mondeTrans.valeur[j]);
         Donnees.Add(LigneCourante);
     end;
     if ConstanteDlg.NewPageCB.itemIndex=0 then AjouteOptionGr(agraphe,donnees);
     ClipBoard.asText := donnees.text;
     if DDE then begin
     if ConstanteDlg.NewPageCB.itemIndex=1
        then Execute(eADD)
        else Execute(eLOAD);
     i := 0;
     imax := listeDonnees.count;
     if DataSaved then dec(imax); // dernire courbe doublon de la courbe courante
     while i<imax do begin
         sleep(1000); // rcup des donnes par Regressi
         ecritOld(i);
         Execute(eADD);
         inc(i);
     end;
     constanteDlg.newPageCB.itemIndex := 1;
     end;
     donnees.free;
end end;

procedure TFormDDE.ExecuteMacro(Sender: TObject; Msg: TStrings);
begin
     if (Msg.Count = 1) then FormMain.setFocus;
end;

procedure TFormDDE.FormCreate(Sender: TObject);
var Ini : TRegIniFile;
begin
    Ini := TRegIniFile.create('Software\Regressi');
    ClientDDE.ServiceApplication := Ini.ReadString('Regressi','Path','c:\regwin\regressi.exe');
    Ini.Free;
    ClientItem.DDEItem := 'ServeurItem';
end;

procedure TFormDDE.EnvoieDonneesCinetique(Agraphe : Tgraphe;DDE : boolean);
var i : indiceVecteur;
    donnees : TstringList;
begin with Agraphe do begin
     Donnees := TstringList.create;
     Donnees.Add(Application.ExeName);
     Donnees.Add('Cintique '+DateTimeToStr(date+time));
     Donnees.Add(ConstanteDlg.EditComm.text);
     Donnees.Add(MondeX.nom+crTab+MondeY.nom);
     Donnees.Add(MondeX.unite+crTab+MondeY.unite);
{$IFDEF DEBUG}
     NbrePoints := 100;
     for i := 0 to pred(NbrePoints) do begin
         Donnees.Add(FloatToStrPoint(i)+crTab+
           FloatToStrPoint(1-exp(-i/100)));
     end;
     {$ELSE}
     for i := 0 to pred(NbrePoints) do begin
         Donnees.Add(FloatToStrPoint(mondeX.valeur[i])+crTab+
           FloatToStrPoint(mondeY.valeur[i]));
     end;
     {$ENDIF}
     ClipBoard.AsText := donnees.text;
     if DDE then if constanteDlg.newPageCB.itemIndex=1
        then Execute(eADD)
        else Execute(eLOAD);
     donnees.free;
     constanteDlg.newPageCB.itemIndex := 1;
end end;

end.

