unit shimadzuMain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  Dialogs, extCtrls, toolWin, comCtrls,  StdCtrls, Menus,
  OoMisc, AdPort, constantes;

  type
     TEtatSpectre = (esBlancEnCours, esSpectreEnCours, esAttente, esLectureAbs, esEcriture);

  var
    reponse : shortString;
    iCourant : integer;
    trNul,trEOT,trENQ : word;
    Sauve,BlancFait,spectreFait : boolean;
    etatSpectre : TetatSpectre;
    oldMin,oldMax : integer;
    dernierCarac : charSet;
    NumeroCom : array[-1..MaxComHandles] of integer;
    arretForce : boolean;
    procedure setLambda(lambda : integer);
    procedure setZero;
    procedure demandeAbs;

implementation

procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
var
  I: Integer;
  Carac : ansiChar;
begin
	for I := 1 to Count do begin
        Carac := VoieSerie.getChar;
        if carac<' '
           then include(dernierCarac,carac)
           else reponse := reponse + carac;
    end;
end;

procedure VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);

procedure TriggerDataNul;
var debut,nombre : integer;
    longueur : integer;
begin
    longueur := length(reponse);
    if longueur>0 then begin
       debut := 1;
       while (debut<longueur) and
              not charInSet(reponse[debut],['+','-','0'..'9']) do inc(debut);
       nombre := 1;
       while ((debut+nombre)<=longueur) and
             charInSet(reponse[debut+nombre],['0'..'9','.',',']) do inc(nombre);
       X.valeur[iCourant] := strToFloatWin(copy(reponse,debut,nombre));
       debut := debut+nombre+1;
       while (debut<longueur) and
              not charInSet(reponse[debut],['+','-','0'..'9']) do inc(debut);
       nombre := 1;
       while ((debut+nombre)<=longueur) and
             charInSet(reponse[debut+nombre],['0'..'9','.',',']) do inc(nombre);
       Abs.valeur[iCourant] := strToFloatWin(copy(reponse,debut,nombre));

       reponse := '';
       voieSerie.output := crAck; // OK et demande de donne suivante
    end;
end;

procedure TriggerDataNulAbs;
var debut,nombre : integer;
    longueur : integer;
    valeurCourante : double;
begin
    longueur := length(reponse); // d+0.356
    if longueur>0 then begin
       debut := 1;
       while (debut<longueur) and
              not charInSet(reponse[debut],['+','-','0'..'9']) do inc(debut);
       nombre := 1;
       while ((debut+nombre)<=longueur) and
             charInSet(reponse[debut+nombre],['0'..'9','.',',']) do inc(nombre);
       reponse := copy(reponse,debut,nombre);
       voieSerie.output := crAck; // OK
       reponse := '';
    end;
end;

begin
	if triggerHandle=trNul then
    case etatSpectre of
        esLectureAbs : TriggerDataNulAbs;
        else TriggerDataNul;
    end;
    if triggerHandle=trEot then begin
       voieSerie.output := crAck;  // fin de dialogue
       etatSpectre := esAttente;
    end;
    if triggerHandle=trEnq then begin
       voieSerie.output := crAck; // demande des donnes
    end;
end;

procedure setZero;
begin
    etatSpectre := esEcriture;
    ecriture('x');
end;

procedure DemandeAbs;
begin
    etatSpectre := esLectureAbs;
    lecture('d');
end;

procedure Blanc;
begin
    etatSpectre := esBlancEnCours;
    blancFait := ecriture('c'+
       intToStr(10*finSE.value)+','+
       intToStr(10*debutSE.value));
    etatSpectre := esAttente;
end;

procedure setLambda(Lambda : integer);
begin
    etatSpectre := esEcriture;
    ecriture('w'+intToStr(10*lambda));
end;

procedure Spectre(debut;fin,vitesse : integer);
var deltaLambda : integer;
    nombre : integer;
begin
    etatSpectre := esSpectreEnCours;
    screen.cursor := crHourGlass;
    iCourant := 0;
    DeltaLambda := fin-debut;
    spectreFait := ecriture('a'+
         intToStr(10*fin)+','+
         intToStr(10*debut)+','+
         intToStr(vitesse+1));
     nombre := deltaLambda;
     case vitesse of
          0 : if DeltaLambda<200
                then nombre := 5*deltaLambda 
                else if DeltaLambda<500
                     then nombre := 2*deltaLambda
                     else nombre := deltaLambda;
          1 : if DeltaLambda<100
                then nombre := 10*deltaLambda
                else if DeltaLambda<200
                   then nombre := 5*deltaLambda
                   else if DeltaLambda<500
                       then nombre := 2*deltaLambda
                       else nombre := deltaLambda;
          2 : if DeltaLambda<500
                  then nombre := 2*deltaLambda
                  else nombre := deltaLambda;
          3 : if DeltaLambda<200
                   then nombre := 5*deltaLambda
                   else if DeltaLambda<500
                       then nombre := 2*deltaLambda
                       else nombre := deltaLambda;
          4 : if DeltaLambda<100
                then nombre := 10*deltaLambda
                else if DeltaLambda<200
                   then nombre := 5*deltaLambda
                   else if DeltaLambda<500
                       then nombre := 2*deltaLambda
                       else nombre := deltaLambda
     end;
     etatSpectre := esSpectreEnCours;     
     lecture('f'+intToStr(nombre));
end;

function envoieCommande(commande : shortString) : boolean;
const TimeOut = 5*18;
var nbre : integer;// comptage des essais
    ET: eventTimer;
begin
     nbre := 0;
     dernierCarac := [];
     voieSerie.output := commande;
     arretForce := false;
     newTimer(ET, timeOut);
     repeat
         VoieSerie.processCommunications;
         Application.processMessages;
         if charInSet(crNak,dernierCarac) then begin // nouvel essai
            voieSerie.output := commande;
            dernierCarac := [];
            newTimer(ET, TimeOut);
            inc(nbre);
         end;
         sleep(100);
     until charInSet(crAck,dernierCarac) or
           (nbre>MaxNack) or
           timerExpired(ET) or arretForce;
     result := charInSet(crAck,dernierCarac);
end;

procedure Connect;
begin
    if connectBtn.down then begin
    try
	  voieSerie.open := true;
    if trEot=0 then trEot := voieSerie.AddDataTrigger(crEot,true);
    if trEnq=0 then trEnq := voieSerie.AddDataTrigger(crEnq,true);    
    if trNul=0 then trNul := voieSerie.AddDataTrigger(crNul,true);
    except
        voieSerie.open := false;
    end;
    end
    else voieSerie.open := false;
    etatSpectre := esAttente;
end;

function TFormMain.debutCom(commande : shortString) : boolean;
begin
     EcritStatus('Envoi de Enquiry ; attente de Acknowledge');
     result := envoieCommande(crENQ); // quasi immdiat rpond ACK
     if result
        then begin
          result := envoieCommande(commande+crNul); // avec attente de ACK
          EcritStatus('Envoi de '+commande);
        end
        else EcritStatus('Pas de rponse  Enquiry');
end;

function TFormMain.ecriture(commande : shortString) : boolean;
// commande type A
begin
     result := debutCom(commande);
     if not Result then exit;
     ecritStatus('Attente de End of text');
     repeat
          VoieSerie.processCommunications;
          Application.processMessages;
          sleep(100);
     until (etatSpectre=esAttente);
 // Commande effectue : rpond EOT
 // rception EOT gnre un Ack en retour et positionne etatSpectre
    result := not arretForce;
    if result
        then ecritStatus('Commande '+commande+' accepte')
        else ecritStatus('Pas de rponse  '+commande);
end;

function lecture(commande : shortString) : boolean;
// commande type B
begin
     result := debutCom(commande);
     if not Result then exit;
     ecritStatus('Attente de Enquiry');
     repeat
          VoieSerie.processCommunications;
          Application.processMessages;
          sleep(100);
     until charInSet(crENQ,dernierCarac) or arretForce;
// rpond ENQ
// rception de ENQ gnre un Ack pour demander les rsultats
     result := charInSet(crEnq,dernierCarac);
     if Result
        then begin
           ecritStatus('Attente des rsultats');
        end
        else begin
           ecritStatus(commande+' non effectue');
           etatSpectre := esAttente;
        end;
end;

end.


