unit shimadzuMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, spin, buttons, extCtrls, toolWin, comCtrls,  StdCtrls, Menus, inifiles,
  OoMisc, AdPort,
  System.ImageList,
  Vcl.CheckLst, Vcl.ImgList,
  constantes, graphker, math, maths;

type
  TFormMain = class(TForm)
    VoieSerie: TApdComPort;
    ToolBar1: TToolBar;
    SaveBtn: TToolButton;
    BlancBtn: TToolButton;
    SpectreBtn: TToolButton;
    StopBtn: TToolButton;
    PrintBtn: TToolButton;
    ExitBtn: TToolButton;
    ImageList1: TImageList;
    SavePopupMenu: TPopupMenu;
    RegressiM: TMenuItem;
    ClipM: TMenuItem;
    FileM: TMenuItem;
    SaveDialog: TSaveDialog;
    ConnectBtn: TToolButton;
    StatusBar1: TStatusBar;
    PaintBox1: TPaintBox;
    Panel1: TPanel;
    GroupBox3: TGroupBox;
    LambdaSE: TSpinEdit;
    LambdaBtn: TBitBtn;
    ZeroBtn: TBitBtn;
    AbsBtn: TBitBtn;
    AbsEdit: TEdit;
    LambdaGB: TGroupBox;
    Maxi: TLabel;
    Mini: TLabel;
    DebutSE: TSpinEdit;
    FinSE: TSpinEdit;
    VitesseRG: TRadioGroup;
    Label1: TLabel;
    Memo1: TMemo;
    AffDeriveeCB: TCheckListBox;
    GroupBox1: TGroupBox;
    YRG: TRadioGroup;
    CinetiqueBtn: TToolButton;
    GrapheMenu: TPopupMenu;
    DeleteCourbeItem: TMenuItem;
    AddBtn: TToolButton;
    ComPorts: TComboBox;
    procedure VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);
    procedure VoieSerieTriggerAvail(CP: TObject; Count: Word);
    procedure ComPortsChange(Sender: TObject);
    procedure DebutSEChange(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure RegressiMClick(Sender: TObject);
    procedure SaveBtnClick(Sender: TObject);
    procedure ConnectBtnClick(Sender: TObject);
    procedure BlancBtnClick(Sender: TObject);
    procedure StopBtnClick(Sender: TObject);
    procedure SpectreBtnClick(Sender: TObject);
    procedure PrintBtnClick(Sender: TObject);
    procedure PaintBox1Paint(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure LambdaBtnClick(Sender: TObject);
    procedure ZeroBtnClick(Sender: TObject);
    procedure AbsBtnClick(Sender: TObject);
    procedure AffDeriveeCBClick(Sender: TObject);
    procedure YRGClick(Sender: TObject);
    procedure ExitBtnClick(Sender: TObject);
    procedure CinetiqueBtnClick(Sender: TObject);
    procedure DeleteCourbeItemClick(Sender: TObject);
    procedure PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure AddBtnClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
  private
    reponse : shortString;
    iCourant : integer;
    trNul,trEOT,trENQ : word;
    Sauve,BlancFait,spectreFait : boolean;
    graphe : Tgraphe;
    etatSpectre : TetatSpectre;
    oldMin,oldMax : integer;
    dernierCarac : charSet;
    courbeProche : integer;
    NumeroCom : array[-1..MaxComHandles] of integer;
    {$IFDEF DEBUG}
    indexFichier : integer;
    {$ENDIF}
    procedure setComPorts;
    procedure SaveItem;
    function envoieCommande(commande : shortString) : boolean;
    function debutCom(commande : shortString) : boolean;
    function ecriture(commande : shortString) : boolean;
    function lecture(commande : shortString) : boolean;
    procedure setBoutons;
    procedure EcritStatus(chaine : string);
  public
    arretForce : boolean;
    procedure setLambda(lambda : integer);
    procedure setZero;
    procedure demandeAbs;
  end;

var
  FormMain: TFormMain;

implementation

uses shimadde, S250CST, shimaCinet;

{$R *.dfm}

procedure TFormMain.EcritStatus(chaine : string);
begin
    statusBar1.simpleText := chaine;
    if cinetiqueForm<>nil then
       cinetiqueForm.statusBar1.simpleText := chaine;
end;

procedure TFormMain.VoieSerieTriggerAvail(CP: TObject; Count: Word);
var
  I: Integer;
  Carac : ansiChar;
begin
	for I := 1 to Count do begin
        Carac := VoieSerie.getChar;
        if carac<' '
           then include(dernierCarac,carac)
           else reponse := reponse + carac;
    end;
end;

procedure TFormMain.VoieSerieTriggerData(CP: TObject; TriggerHandle: Word);

procedure TriggerDataNul;
var debut,nombre : integer;
    longueur : integer;
begin
    longueur := length(reponse);
    if longueur>0 then begin
       debut := 1;
       while (debut<longueur) and
              not charInSet(reponse[debut],['+','-','0'..'9']) do inc(debut);
       nombre := 1;
       while ((debut+nombre)<=longueur) and
             charInSet(reponse[debut+nombre],['0'..'9','.',',']) do inc(nombre);
       graphe.mondeX.valeur[iCourant] := strToFloatWin(copy(reponse,debut,nombre));
       debut := debut+nombre+1;
       while (debut<longueur) and
              not charInSet(reponse[debut],['+','-','0'..'9']) do inc(debut);
       nombre := 1;
       while ((debut+nombre)<=longueur) and
             charInSet(reponse[debut+nombre],['0'..'9','.',',']) do inc(nombre);
       graphe.mondeAbs.valeur[iCourant] := strToFloatWin(copy(reponse,debut,nombre));
       graphe.mondeTrans.valeur[iCourant] := math.power(10,-graphe.mondeAbs.valeur[iCourant]);

       reponse := '';
       graphe.TraceUnPoint(iCourant);
       inc(iCourant);
       graphe.NbrePoints := iCourant;
       voieSerie.output := crAck; // OK et demande de donne suivante
    end;
end;

procedure TriggerDataNulAbs;
var debut,nombre : integer;
    longueur : integer;
    valeurCourante : double;
begin
    longueur := length(reponse); // d+0.356
    if longueur>0 then begin
       debut := 1;
       while (debut<longueur) and
              not charInSet(reponse[debut],['+','-','0'..'9']) do inc(debut);
       nombre := 1;
       while ((debut+nombre)<=longueur) and
             charInSet(reponse[debut+nombre],['0'..'9','.',',']) do inc(nombre);
       reponse := copy(reponse,debut,nombre);
       absEdit.text := reponse;
       voieSerie.output := crAck; // OK
       if (cinetiqueForm<>nil) and
          (cinetiqueForm.AcqEnCours) then begin
            valeurCourante := strToFloatWin(reponse);
            CinetiqueForm.setAbs(valeurCourante);
       end;
       reponse := '';
    end;
end;

begin
	if triggerHandle=trNul then
    case etatSpectre of
        esLectureAbs : TriggerDataNulAbs;
        else TriggerDataNul;
    end;
    if triggerHandle=trEot then begin
       voieSerie.output := crAck;  // fin de dialogue
       screen.cursor := crDefault;
       etatSpectre := esAttente;
       setBoutons;
    end;
    if triggerHandle=trEnq then begin
       voieSerie.output := crAck; // demande des donnes
    end;
end;

procedure TFormMain.YRGClick(Sender: TObject);
begin
    if YRG.itemIndex=0
       then graphe.mondeY := graphe.mondeAbs
       else graphe.mondeY := graphe.mondeTrans;
    paintBox1.Invalidate
end;

procedure TFormMain.ZeroBtnClick(Sender: TObject);
begin
    setZero
end;

procedure TFormMain.setZero;
begin
  {$IFDEF DEBUG} exit; {$ENDIF}
    etatSpectre := esEcriture;
    ecriture('x');
end;

procedure TFormMain.AbsBtnClick(Sender: TObject);
begin
    DemandeAbs
end;

procedure TFormMain.DemandeAbs;
begin
 {$IFDEF DEBUG} exit; {$ENDIF}
    etatSpectre := esLectureAbs;
    screen.cursor := crHourGlass;
    absEdit.text := '';
    setBoutons;
    lecture('d');
end;

procedure TFormMain.AddBtnClick(Sender: TObject);
begin
  graphe.AddCourbeCourante;
  AddBtn.Enabled := false;
end;

procedure TFormMain.AffDeriveeCBClick(Sender: TObject);
var
  I: Integer;
begin
    for I := 1 to 3 do
        graphe.traceDer[i] := affDeriveeCB.Checked[i-1];
    paintBox1.Invalidate;
end;

procedure TFormMain.BlancBtnClick(Sender: TObject);
begin
    etatSpectre := esBlancEnCours;
    blancFait := ecriture('c'+
       intToStr(10*finSE.value)+','+
       intToStr(10*debutSE.value));
    etatSpectre := esAttente;
    setBoutons;
end;

procedure TFormMain.CinetiqueBtnClick(Sender: TObject);
begin
    if cinetiqueForm=nil then
       application.createForm(TcinetiqueForm,cinetiqueForm);
    cinetiqueForm.Show;
end;

procedure TFormMain.ComPortsChange(Sender: TObject);
begin
     voieSerie.ComNumber := NumeroCom[ComPorts.itemIndex];
end;

procedure TFormMain.DebutSEChange(Sender: TObject);
begin
   DebutSE.MaxValue := FinSE.Value - DeltaLambdaMin;
   FinSE.MinValue := DebutSE.Value + DeltaLambdaMin;
   BlancFait := BlancFait and
               (debutSE.value>=oldMin) and
               (debutSE.value<=oldMax);
   oldMin := debutSE.value;
   oldMax := finSE.value;   
end;

procedure TFormMain.DeleteCourbeItemClick(Sender: TObject);
begin
    if courbeProche>=0 then begin
        graphe.listeDonnees.delete(courbeProche);
        paintBox1.invalidate;
    end;
end;

procedure TFormMain.FormActivate(Sender: TObject);
begin
	  setBoutons
end;

procedure TFormMain.FormCreate(Sender: TObject);

Procedure LiTIni;
var ini : TiniFile;
begin
   Ini := TIniFile.Create(nomIniFile);
   try
      voieSerie.ComNumber := Ini.ReadInteger('VoieSerie', 'ComNumber', 1);
      debutSE.value := Ini.ReadInteger( 'Lambda', 'Debut', 500 );
      finSE.value  := Ini.ReadInteger( 'Lambda', 'Fin', 600 );
      vitesseRG.ItemIndex := Ini.ReadInteger( 'Vitesse', 'Valeur', 2);
      if Ini.ReadBool( 'Graphe', 'Yabs', true)
         then YRG.ItemIndex := 0
         else YRG.ItemIndex := 1;
   finally
     Ini.Free;
   end;
   setComPorts;
end;

var v : integer;
begin
    {$IFDEF DEBUG}
    indexFichier := 0;
    {$ENDIF}
    debutSE.MinValue := LambdaMin;
    finSe.MaxValue := lambdaMax;
    graphe := Tgraphe.create;
    graphe.canvas := paintBox1.canvas;
    graphe.setMonde(lambdaMin,0,lambdaMax,maxiAbs);
    graphe.mondeX.nom := CharLambda;
    graphe.mondeAbs.nom := 'A';
    graphe.mondeTrans.nom := 'T';
    graphe.mondeX.unite := 'nm';
    graphe.mondeAbs.unite := '';
    graphe.mondeTrans.unite := '%';
    graphe.mondeX.signif := 'longueur d''onde';
    graphe.mondeAbs.signif := 'absorbance';
    graphe.mondeTrans.signif := 'transmittance';
    graphe.mondeX.zeroInclus := false;
    graphe.mondeTrans.zeroInclus := true;
    graphe.mondeAbs.zeroInclus := true;
    graphe.mondeY := graphe.mondeAbs;
    graphe.ChercheMonde;
{$IF NODEF DEBUG}
    indexFichier := 0;
    trEot := voieSerie.AddDataTrigger(crEOT,true);
    trEnq := voieSerie.AddDataTrigger(crENQ,true);
    trNul := voieSerie.AddDataTrigger(crNUL,true);
{$ENDIF}
    etatSpectre := esAttente;
    oldMin := debutSE.value;
    oldMax := finSE.value;
    for v := -1 to MaxComHandles do
       NumeroCom[v] := 1;
    LitIni;
end;

procedure TFormMain.FormDestroy(Sender: TObject);

Procedure EcritIni;
var ini : TiniFile;
begin
   Ini := TIniFile.Create(nomIniFile);
   try
      Ini.WriteInteger( 'Lambda', 'Debut',debutSE.value );
      Ini.WriteInteger( 'Lambda', 'Fin',finSE.value );
      Ini.WriteInteger( 'Vitesse', 'Valeur', vitesseRG.ItemIndex);
      Ini.WriteBool( 'Graphe', 'Yabs', YRG.ItemIndex=0);
      Ini.WriteInteger('VoieSerie', 'ComNumber', voieSerie.ComNumber);
   finally
     Ini.Free;
   end;

end;

begin
    if voieSerie.open then voieSerie.open := false;
    ecritIni;
end;

procedure TFormMain.setLambda(Lambda : integer);
begin
    etatSpectre := esEcriture;
    ecriture('w'+intToStr(10*lambda));
end;

procedure TFormMain.LambdaBtnClick(Sender: TObject);
begin
    setLambda(lambdaSE.value)
end;

procedure TFormMain.RegressiMClick(Sender: TObject);
begin
   saveBtn.ImageIndex := (Sender as TmenuItem).imageIndex;
   (Sender as TmenuItem).Checked := True;
   SaveBtnClick(Sender);
end;

procedure TFormMain.SaveBtnClick(Sender: TObject);
begin
   if regressiM.Checked then
      if ConstanteDlg.showModal = mrOk then begin
         Sauve := True;
         FormDDE.EnvoieDonneesSpectre(graphe, True);
         constanteDlg.newPageCB.ItemIndex := 1;
      end;
   if clipM.Checked then begin
      Sauve := True;
      FormDDE.EnvoieDonneesSpectre(graphe, False);
   end;
   if fileM.Checked then SaveItem;
   graphe.listeDonnees.clear;
   PaintBox1.Refresh;
end;

Procedure TFormMain.SetComPorts;
var i,j : integer;
begin
    ComPorts.items.clear;
    for i := 1 to MaxComHandles do
        if IsPortAvailable(i) then begin
           ComPorts.Items.Add('COM'+IntToStr(i));
           j := ComPorts.Items.count-1;
           NumeroCom[j] := i;
           if i=VoieSerie.ComNumber then ComPorts.itemIndex := j;
         end;
    if ComPorts.itemIndex<0 then begin
       ComPorts.itemIndex := 0;
       VoieSerie.ComNumber := NumeroCom[0];
    end;
//    ComPorts.visible := Comports.items.count>1;
    ComPorts.visible := true;
    if not IsPortAvailable(voieSerie.ComNumber) and
      (Comports.items.count>0) then begin
          VoieSerie.ComNumber := NumeroCom[0];
          ComPorts.itemIndex := 0;
      end;
end;

procedure TFormMain.SpectreBtnClick(Sender: TObject);
var deltaLambda : integer;
    nombre : integer;
{$IFDEF DEBUG}
    fichierTxt : textFile;
    uneLigne,chaine : string;
    posTab : integer;
const nomFichier : array[0..2] of string =
      ('FiltreVert0.txt','FiltreVert.txt','FiltreVert2.txt');
{$ENDIF}
begin
{$IFDEF DEBUG}
     FileMode := fmOpenRead;
     inc(indexFichier);
     if indexFichier>2 then indexFichier := 0;
     AssignFile(fichierTxt,nomFichier[indexFichier]);
     Reset(fichierTxt);
     graphe.NbrePoints := 0;
     repeat
        readln(fichierTxt,uneLigne);
        posTab := pos(' ',uneLigne);
        if posTab=1 then begin
           uneLigne := copy(uneLigne,2,length(uneLigne));
           posTab := pos(' ',uneLigne);
        end;
        if posTab>0 then begin
          chaine := copy(uneLigne,1,pred(posTab));
          graphe.mondeX.valeur[graphe.NbrePoints] := strToFloatWin(chaine);
          chaine := copy(uneLigne,succ(posTab),length(uneLigne));
          graphe.mondeAbs.valeur[graphe.NbrePoints] := strToFloatWin(chaine);
          graphe.mondeTrans.valeur[graphe.NbrePoints] := math.power(10,-graphe.mondeAbs.valeur[graphe.NbrePoints]);;
          inc(graphe.NbrePoints);
        end;
     until (posTab=0) or eof(fichierTxt);
     CloseFile(fichierTxt);
     FileMode := fmOpenReadWrite;
     spectreFait := true;
     setBoutons;
     paintBox1.Invalidate;
     exit;
{$ENDIF}
    etatSpectre := esSpectreEnCours;
    screen.cursor := crHourGlass;
    iCourant := 0;
    DeltaLambda := finSE.value-debutSE.value;
    spectreFait := ecriture('a'+
         intToStr(10*finSE.value)+','+
         intToStr(10*debutSE.value)+','+
         intToStr(vitesseRG.itemIndex+1));
     nombre := deltaLambda;    
     case vitesseRG.ItemIndex of
          0 : if DeltaLambda<200
                then nombre := 5*deltaLambda 
                else if DeltaLambda<500
                     then nombre := 2*deltaLambda
                     else nombre := deltaLambda;
          1 : if DeltaLambda<100
                then nombre := 10*deltaLambda
                else if DeltaLambda<200
                   then nombre := 5*deltaLambda
                   else if DeltaLambda<500
                       then nombre := 2*deltaLambda
                       else nombre := deltaLambda;
          2 : if DeltaLambda<500
                  then nombre := 2*deltaLambda
                  else nombre := deltaLambda;
          3 : if DeltaLambda<200
                   then nombre := 5*deltaLambda
                   else if DeltaLambda<500
                       then nombre := 2*deltaLambda
                       else nombre := deltaLambda;
          4 : if DeltaLambda<100
                then nombre := 10*deltaLambda
                else if DeltaLambda<200
                   then nombre := 5*deltaLambda
                   else if DeltaLambda<500
                       then nombre := 2*deltaLambda
                       else nombre := deltaLambda
     end;
     etatSpectre := esSpectreEnCours;     
     lecture('f'+intToStr(nombre));
end;

procedure TFormMain.StopBtnClick(Sender: TObject);
begin
   	arretForce := true;
    screen.cursor := crDefault;
    etatSpectre := esAttente;
    setBoutons;
end;

procedure TFormMain.SaveItem;
var
   fichier: textFile;

   procedure ecritEnTeteRW3;
   begin with graphe, constanteDlg do begin
         writeln(fichier, 'EVARISTE REGRESSI WINDOWS 1.0');
         writeln(fichier, symbReg, 3, ' NOM VAR');
         writeln(fichier, CharLambda);
         writeln(fichier, 'A');
         writeln(fichier, 'T');
         writeln(fichier, symbReg, 3, ' UNITE VAR');
         writeln(fichier, 'nm');
         writeln(fichier, '');
         writeln(fichier, '%');
         writeln(fichier, symbReg, 2, ' SIGNIF VAR');
         writeln(fichier, 'Longueur d''onde');
         writeln(fichier, 'Absorbance');
         writeln(fichier, 'Transmittance');
         writeln(fichier, symbReg, '1 ACQUISITION');
         writeln(fichier, Application.ExeName);
      end;
   end; // ecritEnTeteRW3 

   procedure EcritPageRW3;
   var
      j: indiceVecteur;
   begin with graphe do begin
         writeln(fichier, symbReg, 1, ' PAGE COMMENT');
         if constanteDlg.editComm.Text = ''
            then writeln(fichier, DateTimeToStr(date + time))
            else writeln(fichier, constanteDlg.editComm.Text);
         writeln(fichier, symbReg2,intToStr(nbrePoints),' VALEUR VAR');
         for j := 0 to pred(nbrePoints) do
             Writeln(fichier, FloatToStrPoint(mondeX.valeur[j]), ' ',
                              FloatToStrPoint(mondeAbs.valeur[j]), ' ',
                              FloatToStrPoint(mondeTrans.valeur[j]));
      end;
   end; // ecritPageRW3

   procedure EcritPageOld(i : integer);
   var
      j: indiceVecteur;
   begin with graphe,ListeDonnees[i] do begin
         writeln(fichier, symbReg, 1, ' PAGE COMMENT');
         if constanteDlg.editComm.Text = ''
            then writeln(fichier, DateTimeToStr(date + time))
            else writeln(fichier, constanteDlg.editComm.Text);
         writeln(fichier, symbReg2, intToStr(nombre), ' VALEUR VAR');
         for j := 0 to pred(nombre) do
             Writeln(fichier, FloatToStrPoint(X[j]), ' ',
                              FloatToStrPoint(A[j]), ' ',
                              FloatToStrPoint(T[j]));
      end;
   end; // ecritPageRW3

   procedure EcritTableur;
   var
      j: indiceVecteur;
   begin with graphe do begin
         writeln(fichier, 'Spectre Shimadzu ' + DateTimeToStr(date + time));
         Writeln(fichier, CharLambda,crTab, 'A',crTab,'T');
         Writeln(fichier, 'nm', crTab, ' ',crTab,'%');
         writeln(fichier, constanteDlg.editComm.Text);
         for j := 0 to nbrePoints do
             Writeln(fichier, FloatToStrPoint(mondeX.valeur[j]),crTab,
                              FloatToStrPoint(mondeAbs.valeur[j]),crTab,
                              FloatToStrPoint(mondeTrans.valeur[j]));
   end end; // ecritTableur

var
   formatRW3: boolean;
begin
   SaveDialog.Filter := 'Regressi (*.rw3)|*.rw3|Tableur ASCII (*.txt)|*.txt';
   if SaveDialog.Execute then begin
      FormatRW3 := AnsiUpperCase(ExtractFileExt(saveDialog.FileName)) = '.RW3';
      sauve := True;
      AssignFile(fichier, saveDialog.FileName);
      Rewrite(fichier);
      if formatRW3 then begin
         ecritEnTeteRW3;
         ecritPageRW3;
      end
      else ecritTableur;
      CloseFile(fichier);
   end;
end;

function TFormMain.envoieCommande(commande : shortString) : boolean;
const TimeOut = 5*18;
var nbre : integer;// comptage des essais
    ET: eventTimer;
begin
     nbre := 0;
     dernierCarac := [];
     voieSerie.output := commande;
     arretForce := false;
     newTimer(ET, timeOut);
     repeat
         VoieSerie.processCommunications;
         Application.processMessages;
         if charInSet(crNak,dernierCarac) then begin // nouvel essai
            voieSerie.output := commande;
            dernierCarac := [];
            newTimer(ET, TimeOut);
            inc(nbre);
         end;
         sleep(100);
     until charInSet(crAck,dernierCarac) or
           (nbre>MaxNack) or
           timerExpired(ET) or arretForce;
     result := charInSet(crAck,dernierCarac);
end;

procedure TFormMain.ExitBtnClick(Sender: TObject);
begin
    Close;
end;

procedure TFormMain.ConnectBtnClick(Sender: TObject);
begin
    if connectBtn.down then begin
    try
	  voieSerie.open := true;
    if trEot=0 then trEot := voieSerie.AddDataTrigger(crEot,true);
    if trEnq=0 then trEnq := voieSerie.AddDataTrigger(crEnq,true);    
    if trNul=0 then trNul := voieSerie.AddDataTrigger(crNul,true);
    except
        voieSerie.open := false;
        setComPorts;
    end;
    end
    else voieSerie.open := false;
    etatSpectre := esAttente;
    setBoutons;
end;

function TFormMain.debutCom(commande : shortString) : boolean;
begin
     EcritStatus('Envoi de Enquiry ; attente de Acknowledge');
     result := envoieCommande(crENQ); // quasi immdiat rpond ACK
     if result
        then begin
          result := envoieCommande(commande+crNul); // avec attente de ACK
          EcritStatus('Envoi de '+commande);
        end
        else EcritStatus('Pas de rponse  Enquiry');
end;

function TFormMain.ecriture(commande : shortString) : boolean;
// commande type A
begin
     if cinetiqueForm=nil then setBoutons;
     screen.cursor := crHourGlass;
     result := debutCom(commande);
     if not Result then exit;
     ecritStatus('Attente de End of text');
     repeat
          VoieSerie.processCommunications;
          Application.processMessages;
          sleep(100);
     until (etatSpectre=esAttente);
 // Commande effectue : rpond EOT
 // rception EOT gnre un Ack en retour et positionne etatSpectre
    result := not arretForce;
    if result
        then ecritStatus('Commande '+commande+' accepte')
        else ecritStatus('Pas de rponse  '+commande);
    screen.cursor := crDefault;
    if cinetiqueForm=nil
        then setBoutons
        else begin
           if (commande[1]='w') then begin
                cinetiqueForm.lambdaFait := true;
                cinetiqueForm.setBoutons;
           end;
           if (commande[1]='x') then begin
                cinetiqueForm.blancFait := true;
                cinetiqueForm.setBoutons;
           end;
        end;
end;

function TFormMain.lecture(commande : shortString) : boolean;
// commande type B
begin
     setBoutons;
     result := debutCom(commande);
     if not Result then exit;
     ecritStatus('Attente de Enquiry');
     repeat
          VoieSerie.processCommunications;
          Application.processMessages;
          sleep(100);
     until charInSet(crENQ,dernierCarac) or arretForce;
// rpond ENQ
// rception de ENQ gnre un Ack pour demander les rsultats
     result := charInSet(crEnq,dernierCarac);
     if Result
        then begin
           ecritStatus('Attente des rsultats');
           StopBtn.enabled := true;
        end   
        else begin
           ecritStatus(commande+' non effectue');
           screen.cursor := crDefault;
           etatSpectre := esAttente;
           setBoutons;
        end;
end;

procedure TFormMain.PaintBox1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
    if Button=mbRight then
       courbeProche := graphe.CourbeProche(x,y);
end;

procedure TFormMain.PaintBox1Paint(Sender: TObject);
begin
    graphe.largeurEcran := (sender as TPaintBox).Width+2;
    graphe.draw(paintBox1.canvas)
end;

procedure TFormMain.PrintBtnClick(Sender: TObject);
begin
     graphe.imprime;
end;

procedure TFormMain.setBoutons;
begin
    ecritStatus('');
    blancBtn.enabled := voieSerie.open and
       (etatSpectre=esAttente);
    if not VoieSerie.open then
       ecritStatus('Cliquer sur connecter');
 {$IFDEF DEBUG}
     spectreBtn.enabled := true;
 {$ELSE}
    spectreBtn.enabled := voieSerie.open and
       blancFait and
       (etatSpectre=esAttente);
 {$ENDIF}
    stopBtn.enabled := etatSpectre<>esAttente;
    if voieSerie.open
       then connectBtn.Caption := 'Dconnecter'
       else connectBtn.Caption := 'Connecter';
    SaveBtn.enabled := spectreFait and (graphe.NbrePoints>100);
    PrintBtn.enabled := saveBtn.Enabled;
    if saveBtn.enabled then
       statusBar1.simpleText := 'Cliquer sur sauver';
    case etatSpectre of
         esBlancEnCours  : statusBar1.simpleText := 'Blanc en cours';
         esSpectreEnCours : statusBar1.simpleText := 'Spectre en cours';
    end;
    LambdaBtn.enabled := voieSerie.open and
       (etatSpectre=esAttente);
    ZeroBtn.enabled := voieSerie.open and
       (etatSpectre=esAttente);
    AbsBtn.enabled := voieSerie.open and
       (etatSpectre=esAttente);
    AddBtn.Enabled := spectreFait;
end;

end.


